<!--
SPDX-FileCopyrightText: © 2020 Open Networking Foundation <support@opennetworking.org>
SPDX-License-Identifier: Apache-2.0
--!>
# nsd

NSD Authoritative DNS Server

[NSD Documentation](https://nlnetlabs.nl/documentation/nsd/)

By default, listens on 127.0.0.1 and assumes that `unbound` or a similar
recursive resolver or a proxy like `dnscurve` is sending it requests.

Both forward and reverse zones are created.

TODO:

- Handle creating forward-only zones, where the IP address isn't within the subnet

## Requirements

Minimum ansible version: 2.9.5

## Defaults

See the `dns_zones` structure:

```yaml
dns_zones:
  example.com:
    ip_range: 192.168.1.1/24
    ns:
      - gw.example.com.
    a:
      gw: 192.168.1.1
      host1: 192.168.1.2
      host2: 192.168.1.3
      printer: 192.168.1.4
    cname:
      lpr: printer.example.com.
    srv: {}
    txt: {}
```

Note: In the molecule tests, `<zone>.serial` is used for the zonefile serial,
and is set to a static value to guarantee idempotency. In production, this
must be changed every time the zonefile changes, or can be omitted and the
current timestamp is used to generate the serial.  Other DNS roles tried
`complicated solutions
<https://github.com/bertvv/ansible-role-bind/blob/master/templates/bind_zone.j2>`_
to guarantee the serial changes, but that seems like a lot of trouble, and is only useful for zone transfers which are silly/antiquated 

## Example Playbook

```yaml
- hosts: all
  roles:
    - nsd
```

## License and Author

© 2020 Open Networking Foundation <support@opennetworking.org>

License: Apache-2.0
